chiark / gitweb /
Remove obsolete files when deleting a branch
[stgit] / t / test-lib.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 # Copyright (c) 2006 Yann Dirson - tuning for stgit
5 #
6
7 # For repeatability, reset the environment to known value.
8 LANG=C
9 LC_ALL=C
10 PAGER=cat
11 TZ=UTC
12 export LANG LC_ALL PAGER TZ
13 unset AUTHOR_DATE
14 unset AUTHOR_EMAIL
15 unset AUTHOR_NAME
16 unset COMMIT_AUTHOR_EMAIL
17 unset COMMIT_AUTHOR_NAME
18 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
19 unset GIT_AUTHOR_DATE
20 #GIT_AUTHOR_EMAIL=author@example.com
21 #GIT_AUTHOR_NAME='A U Thor'
22 unset GIT_COMMITTER_DATE
23 #GIT_COMMITTER_EMAIL=committer@example.com
24 #GIT_COMMITTER_NAME='C O Mitter'
25 unset GIT_DIFF_OPTS
26 unset GIT_DIR
27 unset GIT_EXTERNAL_DIFF
28 unset GIT_INDEX_FILE
29 unset GIT_OBJECT_DIRECTORY
30 unset SHA1_FILE_DIRECTORIES
31 unset SHA1_FILE_DIRECTORY
32 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
33 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
34
35 # Each test should start with something like this, after copyright notices:
36 #
37 # test_description='Description of this test...
38 # This test checks if command xyzzy does the right thing...
39 # '
40 # . ./test-lib.sh
41
42 error () {
43         echo "* error: $*"
44         trap - exit
45         exit 1
46 }
47
48 say () {
49         echo "* $*"
50 }
51
52 test "${test_description}" != "" ||
53 error "Test script did not set test_description."
54
55 while test "$#" -ne 0
56 do
57         case "$1" in
58         -d|--d|--de|--deb|--debu|--debug)
59                 debug=t; shift ;;
60         -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
61                 immediate=t; shift ;;
62         -h|--h|--he|--hel|--help)
63                 echo "$test_description"
64                 exit 0 ;;
65         -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
66                 export STGIT_DEBUG_LEVEL="-1"
67                 verbose=t; shift ;;
68         *)
69                 break ;;
70         esac
71 done
72
73 exec 5>&1
74 if test "$verbose" = "t"
75 then
76         exec 4>&2 3>&1
77 else
78         exec 4>/dev/null 3>/dev/null
79 fi
80
81 test_failure=0
82 test_count=0
83
84 trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit
85
86
87 # You are not expected to call test_ok_ and test_failure_ directly, use
88 # the text_expect_* functions instead.
89
90 test_ok_ () {
91         test_count=$(expr "$test_count" + 1)
92         say "  ok $test_count: $@"
93 }
94
95 test_failure_ () {
96         test_count=$(expr "$test_count" + 1)
97         test_failure=$(expr "$test_failure" + 1);
98         say "FAIL $test_count: $1"
99         shift
100         echo "$@" | sed -e 's/^/        /'
101         test "$immediate" = "" || { trap - exit; exit 1; }
102 }
103
104
105 test_debug () {
106         test "$debug" = "" || eval "$1"
107 }
108
109 test_run_ () {
110         eval >&3 2>&4 "$1"
111         eval_ret="$?"
112         return 0
113 }
114
115 test_expect_failure () {
116         test "$#" = 2 ||
117         error "bug in the test script: not 2 parameters to test-expect-failure"
118         say >&3 "expecting failure: $2"
119         test_run_ "$2"
120         if [ "$?" = 0 -a "$eval_ret" != 0 ]
121         then
122                 test_ok_ "$1"
123         else
124                 test_failure_ "$@"
125         fi
126 }
127
128 test_expect_success () {
129         test "$#" = 2 ||
130         error "bug in the test script: not 2 parameters to test-expect-success"
131         say >&3 "expecting success: $2"
132         test_run_ "$2"
133         if [ "$?" = 0 -a "$eval_ret" = 0 ]
134         then
135                 test_ok_ "$1"
136         else
137                 test_failure_ "$@"
138         fi
139 }
140
141 test_expect_code () {
142         test "$#" = 3 ||
143         error "bug in the test script: not 3 parameters to test-expect-code"
144         say >&3 "expecting exit code $1: $3"
145         test_run_ "$3"
146         if [ "$?" = 0 -a "$eval_ret" = "$1" ]
147         then
148                 test_ok_ "$2"
149         else
150                 test_failure_ "$@"
151         fi
152 }
153
154 # Most tests can use the created repository, but some amy need to create more.
155 # Usage: test_create_repo <directory>
156 test_create_repo () {
157         test "$#" = 1 ||
158         error "bug in the test script: not 1 parameter to test-create-repo"
159         owd=`pwd`
160         repo="$1"
161         mkdir "$repo"
162         cd "$repo" || error "Cannot setup test environment"
163         git-init-db >&3 2>&4 ||
164         error "cannot run git-init-db -- have you installed git-core?"
165         mv .git/hooks .git/hooks-disabled
166         echo "empty start" |
167         git-commit-tree `git-write-tree` >.git/refs/heads/master 2>&4 ||
168         error "cannot run git-commit -- is your git-core functioning?"
169         cd "$owd"
170 }
171
172 test_done () {
173         trap - exit
174         case "$test_failure" in
175         0)
176                 # We could:
177                 # cd .. && rm -fr trash
178                 # but that means we forbid any tests that use their own
179                 # subdirectory from calling test_done without coming back
180                 # to where they started from.
181                 # The Makefile provided will clean this test area so
182                 # we will leave things as they are.
183
184                 say "passed all $test_count test(s)"
185                 exit 0 ;;
186
187         *)
188                 say "failed $test_failure among $test_count test(s)"
189                 exit 1 ;;
190
191         esac
192 }
193
194 # Test the binaries we have just built.  The tests are kept in
195 # t/ subdirectory and are run in trash subdirectory.
196 PATH=$(pwd)/..:$PATH
197 HOME=$(pwd)/trash
198 export PATH HOME
199
200
201 # Test repository
202 test=trash
203 rm -fr "$test"
204 test_create_repo $test
205 cd "$test"